# Bash completion for rebase-helper
# Copyright (C) 2013-2014 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# he Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Author: Tomas Hozza <thozza@redhat.com>

shopt -s extglob

_rebase-helper()
{
    local rh_options=("-h --help" "--version" "-v --verbose" "-b --build-only" "--comparepkgs-only" "-p --patch-only" "--buildtool" "--pkgcomparetool" "--outputtool" "--versioneer" "--not-download-sources" "-w --keep-workspace" "-c --continue" "--color" "--disable-inapplicable-patches" "--non-interactive" "--build-tasks" "--builds-nowait" "--builder-options=" "--build-retries" "--results-dir" "--get-old-build-from-koji")
    local rh_choices=("" "" "" "" "" "" "copr koji mock rpmbuild" "abipkgdiff csmock pkgdiff rpmdiff" "json text" "anitya pypi rubygems" "" "" "" "always never auto" "" "" "" "" "" "" "" "")
    local rh_extensions=@(tar.xz|bz2|tar.bz2|tar.gz|tgz|zip|gem)

    local cur prev opt

    _get_comp_words_by_ref -n = cur prev
    _split_longopt

    # complete choices, if the last word is known option which has some
    for idx in "${!rh_options[@]}"; do
        if [[ "${rh_options[idx]}" == *"${prev}"* ]]; then
            if [[ -n "${rh_choices[idx]}" ]]; then
                COMPREPLY=( $(compgen -W "${rh_choices[idx]}" -- "${cur}") )
                return 0
            fi
            break
        fi
    done

    # complete options
    COMPREPLY=( $(compgen -W "$(echo "${rh_options[@]}")" -- "${cur}") )

    # add recognized archive extensions
    _filedir "${rh_extensions}"

    return 0
}

complete -F _rebase-helper rebase-helper
